=== debian/changelog ===
openvdb (7.0.0-3ubuntu3) groovy; urgency=medium

  * Rebuild against new libopenexr25.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 05 Sep 2020 17:19:51 +0200

openvdb (7.0.0-3ubuntu2) groovy; urgency=medium

  * No change rebuild against new ilmbase ABI.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 27 Aug 2020 23:39:11 +0100

openvdb (7.0.0-3ubuntu1) groovy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Don't request a specific python3 version.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Apr 2020 21:46:13 +0200

openvdb (7.0.0-3) unstable; urgency=medium

  * d/vdb_lod.1: Fix typo in man page
  * d/control: Not-ideal solution for building against default python version. Closes: #951829
  * d/control: Remove lintian warning ancient-python-version-field

 -- Mathieu Malaterre <malat@debian.org>  Fri, 10 Apr 2020 21:24:02 +0200

openvdb (7.0.0-2) unstable; urgency=medium

  * d/control: Add missing ref to vdb_lod

 -- Mathieu Malaterre <malat@debian.org>  Mon, 23 Mar 2020 08:49:33 +0100

openvdb (7.0.0-1) experimental; urgency=medium

  * New upstream version 7.0.0
  * d/patches: Refresh patches for new release
  * d/control: Update package version since new ABI
  * d/rules: Update rules file to match new upstream
  * d/control: Replace python3-all-dev with python3.7-dev. Closes: #951829
  * d/control: Remove dependency to jemalloc. See #951704 for details
  * d/rules: Add missing log4cplus cmake option

 -- Mathieu Malaterre <malat@debian.org>  Thu, 05 Mar 2020 15:55:40 +0000
